#include "testlib.h"

#include <bits/stdc++.h>
 
using namespace std;
 
const int MAXN[8] = {200'000, 20, 500, 200'000, 200'000, 200'000, 200'000, 200'000};
const int MAXM[8] = {200'000, 500, 250, 200'000, 1, 1, 200'000, 200'000};
const int MAXT[8] = {400'000, 1000, 500, 400'000, 400'000, 400'000, 400'000, 400'000};
const string SYMBOLS[8] = {"[a-z]", "[a-z]", "[a-z]", "[a-a]", "[a-b]", "[a-z]", "[a-b]", "[a-z]"};
const int MAXLEN = 200'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int group = opt<int>("group");
    int n = opt<int>("n", MAXN[group]);
    int m = opt<int>("m", MAXM[group]);
    int T = opt<int>("T", MAXT[group]);
    string type_s = opt<string>("type_s", "random");
    string type_t = opt<string>("type_t", "random");
    string possible = opt<string>("alphabet", SYMBOLS[group]);
    vector<int> lens = rnd.partition(m, T, 2);
    for (int i = 0; i < m; i++) {
        lens[i] = min(lens[i], MAXLEN);
    }
    string s;
    if (type_s == "random") {
        s = rnd.next(SYMBOLS[group] + "{" + to_string(n) + "-" + to_string(n) + "}");
    } else if (type_s == "blocks") {
        int cnt_char_block = opt<int>("cnt_char_block", 1);
        vector<char> all_chars;
        for (char c = possible[1]; c <= possible[3]; c++) {
            for (int i = 0; i < cnt_char_block; i++) {
                all_chars.push_back(c);
            }
        }
        while (s.size() < n) {
            shuffle(all_chars.begin(), all_chars.end());
            for (char c : all_chars) s += c;
        }
        while (s.size() > n) {
            s.pop_back();
        }
    } else if (type_s == "sorted") {
        vector<char> all_chars;
        for (char c = possible[1]; c <= possible[3]; c++) {
            all_chars.push_back(c);
        }
        vector<int> cnt = rnd.partition((int)all_chars.size(), n, 0);
        string need_shuffle = opt<string>("shuffle", "sort");
        if (need_shuffle == "shuffle") {
            shuffle(all_chars.begin(), all_chars.end());
        } else if (need_shuffle == "rsort") {
            sort(all_chars.rbegin(), all_chars.rend());
        }
        for (int i = 0; i < cnt.size(); i++) {
            s += string(cnt[i], all_chars[i]);
        }
    } else if (type_s == "thue-morse") {
        //abbabaab
        s = "a";
        while (s.size() < n) {
            string was = s;
            for (char c : was) {
                if (c == 'a') {
                    s += 'b';
                } else {
                    s += 'a';
                }
            }
        }
        while (s.size() > n) {
            s.pop_back();
        }
    } else if (type_s == "period") {
        int periods = opt<int>("periods", 1);
        int len_period = n / periods;
        string ss = rnd.next(possible + "{" + to_string(n) + "-" + to_string(n) + "}");
        while (s.size() < n) {
            s += ss;
        }
        while (s.size() > n) {
            s.pop_back();
        }
    } else if (type_s == "two_halfs") {
        vector<char> all_chars;
        for (char c = possible[1]; c <= possible[3]; c++) {
            all_chars.push_back(c);
        }
        shuffle(all_chars.begin(), all_chars.end());
        for (int i = 0; i < n / 2; i++) {
            s += all_chars[rnd.next(0, (int)all_chars.size() / 2 - 1)];
        }
        for (int i = n / 2; i < n; i++) {
            s += all_chars[rnd.next((int)all_chars.size() / 2, (int)all_chars.size() - 1)];
        }
    }
    cout << n << " " << m << "\n";
    cout << s << '\n';
    if (type_t == "random") {
        for (int i = 0; i < m; i++) {
            string t = rnd.next(possible + "{" + to_string(lens[i]) + "-" + to_string(lens[i]) + "}");
            cout << t << '\n';
        }
    } else if (type_t == "substr") {
        for (int i = 0; i < m; i++) {
            string t;
            if (lens[i] > n) {
                t = rnd.next(possible + "{" + to_string(lens[i]) + "-" + to_string(lens[i]) + "}");
            } else {
                t = s.substr(rnd.next(0, n - lens[i]), lens[i]);
            }
            cout << t << '\n';
        }
    } else if (type_t == "kth") {
        int startl = opt<int>("startl", 0);
        int startr = opt<int>("startr", startl);
        int lk = opt<int>("lk", 3);
        int rk = opt<int>("rk", lk);
        for (int i = 0; i < m; i++) {
            string t;
            int pos = rnd.next(startl, startr);
            while (t.size() < lens[i]) {
                t += s[pos];
                pos = (pos + rnd.next(lk, rk)) % n;
            }
            cout << t << "\n";
        }
    } else if (type_t == "any_subseq") {
        vector<int> last_vis(n, -1);
        for (int i = 0; i < m; i++) {
            string t;
            if (lens[i] > n) {
                t = rnd.next(possible + "{" + to_string(lens[i]) + "-" + to_string(lens[i]) + "}");
            } else {
                vector<int> lst;
                while (lst.size() != lens[i]) {
                    int npos = rnd.next(0, n - 1);
                    if (last_vis[npos] != i) {
                        lst.push_back(npos);
                        last_vis[npos] = i;
                    }
                }
                sort(lst.begin(), lst.end());
                for (int x : lst) t += s[x];
            }
            cout << t << '\n';
        }
    }
    return 0;
}
