//  Nikita Golikov, 2024
#pragma GCC optimize("Ofast,O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  string s; cin >> s;
  while (m--) {
    string t; cin >> t;
    int lent = int(t.size());
    int left = 0;
    int right = n;
    while (left + 1 != right) {
      int mid = (left + right) / 2;
      if (ll(lent - 1) * (mid - 1) + lent > n) {
        right = mid;
        continue;
      }
      int pos = 0;
      bool ok = true;
      for (char ch : t) {
        auto npos = s.find(ch, pos);
        if (npos == string::npos) {
          ok = false;
          break;
        }
        pos = int(npos) + mid;
      }
      if (ok) {
        left = mid;
      } else {
        right = mid;
      }
    }
    if (left == 0) {
      cout << -1 << "\n";
    } else {
      cout << left << "\n";
    }
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
